import Day3Lib (processInput1, processInput2)
import System.IO
import Test.HUnit

testCases1 =
  [ ("data/input030.txt", 157),
    ("data/input031.txt", 8153)
  ]

testCase1 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual "input test" result $ processInput1 contents
    )

testCases2 =
  [ ("data/input030.txt", 70),
    ("data/input031.txt", 2342)
  ]

testCase2 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual "input test" result $ processInput2 contents
    )

tests =
  TestList $
    [TestCase (testCase1 c) | c <- testCases1]
      ++ [TestCase (testCase2 c) | c <- testCases2]

main :: IO ()
main = do
  runTestTT tests
  return ()
