import Day7Lib
import Test.HUnit

tNewSession =
  TestCase $
    assertEqual
      "new session"
      (Session {pwd = ["/"], filesystem  = Dir "/" Nothing []})
      (newSession)

tNewDir1 = 
  TestCase $
    assertEqual
      "new dir 1"
      (Session {pwd = ["/", "a"], filesystem  = Dir "/" Nothing [Dir "a" Nothing []]})
      (let s = newSession in cd s "a")

tNewFile1 =
  TestCase $
    assertEqual
      "new dir 1"
      (Session {pwd = ["/"], filesystem  = Dir "/" Nothing [File "b" (Just 100)]})
      (let s = newSession in touch s "b" 100)


tests =
  TestList $
    [
      tNewSession,
      tNewDir1,
      tNewFile1
    ]

main :: IO ()
main = do
  runTestTT tests
  return ()
